package backend;


import java.io.*;
import java.util.*;

import backend.operators.*;

/**
 * <p>berschrift: </p>
 * <p>Beschreibung: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Organisation: </p>
 * @author unbekannt
 * @version 1.0
 */

/*  ALIGNMENT
 *
 *  ProgHeaderTable: 4 Byte
 *  1. Load-Segment: 0x1000 Bytes  (4k)
 *  2. Load-Segment: 0x1000 Bytes  (4k)
 *
 *
 *  Asm:  0x10 Byte (16)
 *  Data: 4 Bytes
 *  Str:  no alignment
 */



public class BinarFile {

  private List asmList;
//  private Map labelTable;


  // Grundeinstellungen
  public int relocOffset = /*0x7000000*/0;   // map the file to this adress into adress space
  private int ProgHeaderEntrys = 3;
  private int SectHeaderEntrys = 4;
  private int sysDataSize = 0;      // Input/Output-Strings,...
  private int StringTableSize = 24;


  public static long e_shstrndx=0x0;       // ???  ( = SHN_UNDEF )



  // Konstanten
  private int ELFHeaderSize = 0x34;
  private int ProgHeaderEntrySize = 0x20;
  private int SectHeaderEntrySize = 0x28;

  // whrend der Laufzeit zu setzen
  private int AssemblerSize;    // code
  private int userDataSize;     // temp
  private int entry;

  // zusammengesetzte Werte
  private int ProgHeaderSize() {
    return ProgHeaderEntrys*ProgHeaderEntrySize;
  }
  private int SectHeaderSize() {
    return SectHeaderEntrys*SectHeaderEntrySize;
  }
  private int DataSize() {
    return sysDataSize+userDataSize;
  }


  public BinarFile() {
    // Programm knnte Quelldateinamen+Quellverzeichnis bernehmen und Endung ndern
    FileName = "test.out";
    Status=0;
    asmList = null;

    AssemblerSize = 0;
    userDataSize = 0;
    entry = 0;

    System.out.println("\nHello World! Will write executable binar object-file.\n");
  }

  private int alignSize(int value, int alignment) {
    while ((value%alignment)!=0) value++;
    return value;
  }


  /*  ACHTUNG!!!
   *
   *  Alle get...Offset()-Methoden liefern die Offsets im Adressraum des
   *  Prozesses. Bentigt man die Datei-Offsets (im Binrfile), so mu
   *  noch relocOffset von diesem Wert subtrahiert werden. (relocOffset
   *  ist deswegen public!)
   */

  public int getELFHeaderOffset() {
    return relocOffset;
  }

  public int getProgHeaderOffset() {
    return getELFHeaderOffset() + ELFHeaderSize;
  }

  public int getAssemblerOffset() {
    return getProgHeaderOffset() + ProgHeaderSize();
  }

  public int getDataOffset() {
    return getAssemblerOffset() + AssemblerSize;
  }

  public int getSysDataOffset() {
    return getDataOffset();
  }

  public int getUserDataOffset() {
    return getDataOffset() + sysDataSize;
  }

  public int getStringTableOffset() {
    return getDataOffset() + DataSize();
  }

  public int getSectHeaderOffset() {
    return getStringTableOffset() + StringTableSize;
  }



  public void setAssemblerSize(int size) {
    size = alignSize(size,1);
    AssemblerSize = size;
  }

  public void setUserDataSize(int size) {
    size = alignSize(size,4);
    userDataSize = size;
  }

  public void setEntryPoint(int offset) {
    entry = offset;
  }

  public boolean validValues() {
    boolean OK=true;
    if (AssemblerSize==0) OK=false;
    if ( userDataSize==0) OK=false;
    if (        entry==0) OK=false;

    System.out.println(AssemblerSize);
    System.out.println(userDataSize);
    System.out.println(entry);

    return OK;
  }

/*
  public void buildLabelTable() {
    Iterator it = asmList.iterator();
    AsmStatement stat;
    AsmLabel label;

    while(it.hasNext()){
      stat = (AsmStatement)it.next();

      if (stat instanceof AsmLabel) {
         label = (AsmLabel)stat;
         labelTable.put(label.getName(),label);
         System.out.println("Label >"+label.getName()+"< eingefgt!");
      }
    }
  }
*/

  protected AsmLabel getAsmLabel(String searched) {
    Iterator it = asmList.iterator();
    AsmStatement stat=null;
    boolean noAbort = true;
    boolean found = false;

    while(noAbort){
      stat = (AsmStatement)it.next();

      if (stat instanceof AsmLabel) {
         found = ((AsmLabel)stat).is(searched);
      }
      noAbort = it.hasNext();
      if (found) noAbort=false;
    }

    if (found) return ((AsmLabel)stat);
    else return null;
  }




  /* (OLD) RECYCLED CODE */



   private byte Status;
   private String FileName;
   private File f;
   private FileOutputStream fos;



   /*
    *  Beim ffnen der Datei:
    *  Existiert die Datei noch nicht, wird sie neu angelegt.
    *  Existiert die Datei, so wird sie geffnet und der Inhalt gelscht.
    *
    *  Ohne den Aufruf von bw.close() werden die Schreibe-Operationen
    *  nicht persistent.
    */

   public void WriteBinarFile(List AssemblerList) {
     asmList = AssemblerList;
     //buildLabelTable();

/*
     AsmLabel lab = getAsmLabel("Entry");
     if (lab!=null) {
        setEntryPoint(lab.getPos());
        System.out.println("Label Entry an Code-Position "+lab.getPos()+"!");
     } else {
       System.out.println("ERROR: Label Entry not found!");
     }
 */

     if (validValues()) {
        System.out.println("BinarFile.WriteBinarFile(): Object File will be generated");
        CreateFile();
        WriteELFHeader();
        WritePHT();
        WriteTextSeg();
        WriteDataSeg();
        WriteStrTab();
        WriteSHT();
        SaveCloseFile();
        System.out.println("BinarFile.WriteBinarFile(): Object File has been generated");
        System.out.println("BinarFile.WriteBinarFile(): Obj-size should be "+String.valueOf(this.getSectHeaderOffset()+this.SectHeaderSize()-this.relocOffset));
     }
     else {
        System.out.println("BinarFile.WriteBinarFile(): Sorry.");
     }
   }


   public void CreateFile() {
     try{
       f = new File(FileName);
       fos = new FileOutputStream(f);
     }
     catch(Exception e)
     {
       System.out.print("CreateFile: ");
       System.out.println(e.getMessage());
     }
   }

   public void SaveCloseFile() {
     try{
       fos.close();
     }
     catch(Exception e)
     {
       System.out.print("Close&SaveFile: ");
       System.out.println(e.getMessage());
     }
   }

   public static byte[] WriteLongToByteList(long value, byte[] list, int off) {
     // ENDIAN FOR X86-ELF-Format, SIGNED
     if (value>=0) {
       list[off+0] = (byte)(value%256); value /= 256;
       list[off+1] = (byte)(value%256); value /= 256;
       list[off+2] = (byte)(value%256); value /= 256;
       list[off+3] = (byte)(value%256);
     }
     else {
       list[off+0] = (byte)(value%256); value /= 256;
       if (value==0) list[off+1] = (byte)(0xff); else list[off+1] = (byte)(value%256-1); value /= 256;
       if (value==0) list[off+2] = (byte)(0xff); else list[off+2] = (byte)(value%256-1); value /= 256;
       if (value==0) list[off+3] = (byte)(0xff); else list[off+3] = (byte)(value%256-1);
     }
     return list;
   }

   public static byte[] Write16bitToByteList(long value, byte[] list, int off) {
     // ENDIAN FOR X86-ELF-Format, UNSIGNED
     list[off+0] = (byte)(value%256); value /= 256;
     list[off+1] = (byte)(value%256);
     return list;
   }



   public void WriteELFHeader() {

     try {
       byte[] buf = new byte[ELFHeaderSize];

       /* write e_ident */
       buf[0]=0x7f;     buf[ 8]=0x00;
       buf[1]=0x45;     buf[ 9]=0x00;
       buf[2]=0x4c;     buf[10]=0x00;
       buf[3]=0x46;     buf[11]=0x00;
       buf[4]=0x01;     buf[12]=0x00;
       buf[5]=0x01;     buf[13]=0x00;
       buf[6]=0x01;     buf[14]=0x00;
       buf[7]=0x00;     buf[15]=0x00;
       /* write e_type */
       buf = Write16bitToByteList(0x2,buf,16);
       /* write e_machine */
       buf = Write16bitToByteList(0x3,buf,18);
       /* write e_version */
       buf = WriteLongToByteList(0x1,buf,20);
       /* write e_entry */
       buf = WriteLongToByteList(entry,buf,24);
       /* write e_phoff */
       buf = WriteLongToByteList( (getProgHeaderOffset()-relocOffset) ,buf,28);
       /* write e_shoff */
       buf = WriteLongToByteList( (getSectHeaderOffset()-relocOffset) ,buf,32);
       /* write e_flags */
       buf = WriteLongToByteList(0x0,buf,36);
       /* write e_ehsize */
       buf = Write16bitToByteList(ELFHeaderSize,buf,40);
       /* write e_phentsize */
       buf = Write16bitToByteList(ProgHeaderEntrySize,buf,42);
       /* write e_phnum */
       buf = Write16bitToByteList(ProgHeaderEntrys,buf,44);
       /* write e_shentsize */
       buf = Write16bitToByteList(SectHeaderEntrySize,buf,46);
       /* write e_shnum */
       buf = Write16bitToByteList(SectHeaderEntrys,buf,48);
       /* write e_shstrndx */
       buf = Write16bitToByteList(e_shstrndx,buf,50);
       fos.write(buf);
     }
     catch (Exception e) {
       System.out.print("ELF-Header: ");
       System.out.println(e.getMessage());
     }
   }

   /* writes Program Header Table */
   public void WritePHT() {

     try {
       byte[] buf = new byte[ProgHeaderEntrySize];

       /* PHD-entry */
       buf = WriteLongToByteList (0x6, buf, 0);  // 0x6 = pt_phdr
       buf = WriteLongToByteList ( (getProgHeaderOffset()-relocOffset), buf, 4);
       buf = WriteLongToByteList (getProgHeaderOffset(), buf, 8);
       buf = WriteLongToByteList (getProgHeaderOffset(), buf,12);
       buf = WriteLongToByteList (ProgHeaderSize(), buf,16);
       buf = WriteLongToByteList (ProgHeaderSize(), buf,20);
       buf = WriteLongToByteList (0x5, buf,24);
       buf = WriteLongToByteList (0x4, buf,28);
       fos.write(buf);

       /* executable LOAD-segment */
       buf = WriteLongToByteList (0x1, buf, 0);  // 0x1 = pt_load
       buf = WriteLongToByteList (0x0, buf, 4);
       buf = WriteLongToByteList (relocOffset, buf, 8);
       buf = WriteLongToByteList (relocOffset, buf,12);
       buf = WriteLongToByteList ( (ELFHeaderSize+ProgHeaderSize()+AssemblerSize) , buf,16);
       buf = WriteLongToByteList ( (ELFHeaderSize+ProgHeaderSize()+AssemblerSize) , buf,20);
       buf = WriteLongToByteList (0x5, buf,24);
       buf = WriteLongToByteList (0x1000, buf,28);
       fos.write(buf);

       /* writeable LOAD-segment */
       buf = WriteLongToByteList (0x1, buf, 0);  // 0x1 = pt_load
       buf = WriteLongToByteList ( (getDataOffset()-relocOffset) , buf, 4);
       buf = WriteLongToByteList (getDataOffset(), buf, 8);
       buf = WriteLongToByteList (getDataOffset(), buf,12);
       buf = WriteLongToByteList (DataSize(), buf,16);
       buf = WriteLongToByteList (DataSize(), buf,20);
       buf = WriteLongToByteList (0x6, buf,24);
       buf = WriteLongToByteList (0x1000, buf,28);
       fos.write(buf);
     }
     catch (Exception e) {
       System.out.print("Program Header Table: ");
       System.out.println(e.getMessage());
     }
   }

   /* writes Text Segment */
   public void WriteTextSeg() {

     try {
       byte[] buf = new byte[AssemblerSize];

//* THIS WILL WORK, BUT THE GENERATED FILE ISNT EXECUTABLE...
       Iterator it = asmList.iterator();
       AsmStatement stat;
       int codePos=0;
       int asmOffset = getAssemblerOffset();

       System.out.println("BinarFile.WriteTextSeg(): Will start my work :-)");


       // durch die Codeblock-Liste iterieren und Adressen vergeben
       while(it.hasNext()){
         stat = (AsmStatement)it.next();


         if ((codePos+asmOffset) != stat.getPos()) {
            System.out.println("BinarFile.WriteTextSeg(): Address Error!");
         }


        if (stat==null) System.out.println("ERROR: stat = null");

//         System.out.print("BinarFile.WriteTextSeg(): At position ");
//         System.out.println(codePos);

         buf = stat.getCode(buf,codePos);
//         System.out.println("BinarFile.WriteTextSeg(): Code written\n");
         codePos += stat.getLength();
       }


/*  this will run (for testing)

       int i=0;
       while (i<(AssemblerSize-2)) {
         buf[i] = (byte)(0x90);  // default: NOP
         i++;
       }
       buf[AssemblerSize-2] = (byte)(0xeb);  // JMP
       buf[AssemblerSize-1] = (byte)(0xfe);  // to the JMP
//  buf[AssemblerSize-2] = 0xe0;  // to the first NOP
//*/
       fos.write(buf);
     }
     catch (Exception e) {
       System.out.print("Text Segment: ");
       System.out.println(e.getMessage());
     }
   }

   /* writes Data Segment */
   public void WriteDataSeg() {

     try {
       byte[] buf = new byte[DataSize()];
       int i=0;
       while (i<DataSize()) {
         buf[i] = 0;
//         buf[i] = 32;  // default: <Space>
         i++;
       }

       // WriteSysData();
       // WriteUsrDate() : Schleife schreibe Nullen in Puffer

/*
       buf[ 0] =  72;   // H
       buf[ 1] = 101;   // e
       buf[ 2] = 108;   // l
       buf[ 3] = 108;   // l
       buf[ 4] = 111;   // o
       buf[ 6] =  87;   // W
       buf[ 7] = 111;   // o
       buf[ 8] = 114;   // r
       buf[ 9] = 108;   // l
       buf[10] = 100;   // d
       buf[11] =  10;   // \n
*/
       fos.write(buf);
     }
     catch (Exception e) {
       System.out.print("Data Segment: ");
       System.out.println(e.getMessage());
     }
   }

   /* writes String Table */
   public void WriteStrTab() {

     try {
       byte[] buf = new byte[StringTableSize];

       buf[ 0] =  46;
       buf[ 1] = 100;
       buf[ 2] =  97;
       buf[ 3] = 116;
       buf[ 4] =  97;
       buf[ 5] = 0x0;
       buf[ 6] =  46;
       buf[ 7] = 116;
       buf[ 8] = 101;
       buf[ 9] = 120;
       buf[10] = 116;
       buf[11] = 0x0;
       buf[12] =  46;
       buf[13] = 115;
       buf[14] = 104;
       buf[15] = 115;
       buf[16] = 116;
       buf[17] = 114;
       buf[18] = 116;
       buf[19] =  97;
       buf[20] =  98;
       buf[21] = 0x0;
       buf[22] = 0x0;
       buf[23] = 0x0;

       fos.write(buf);
     }
     catch (Exception e) {
       System.out.print("String Table: ");
       System.out.println(e.getMessage());
     }
   }

   /* writes Section Header Table */
   public void WriteSHT() {

     try {
       byte[] buf = new byte[SectHeaderEntrySize];

       /* zero-entry */
       buf = WriteLongToByteList (0x0, buf, 0);
       buf = WriteLongToByteList (0x0, buf, 4);
       buf = WriteLongToByteList (0x0, buf, 8);
       buf = WriteLongToByteList (0x0, buf,12);
       buf = WriteLongToByteList (0x0, buf,16);
       buf = WriteLongToByteList (0x0, buf,20);
       buf = WriteLongToByteList (0x0, buf,24);
       buf = WriteLongToByteList (0x0, buf,28);
       buf = WriteLongToByteList (0x0, buf,32);
       buf = WriteLongToByteList (0x0, buf,36);
       fos.write(buf);

       /* text-entry */
       buf = WriteLongToByteList (0x6, buf, 0);
       buf = WriteLongToByteList (0x1, buf, 4);   // PROGBITS
       buf = WriteLongToByteList (0x6, buf, 8);   // alloc+exec
       buf = WriteLongToByteList (getAssemblerOffset(), buf,12);
       buf = WriteLongToByteList ((getAssemblerOffset()-relocOffset), buf,16);  //file-pos
       buf = WriteLongToByteList (AssemblerSize, buf,20);  //file-size
       buf = WriteLongToByteList (0x0, buf,24);
       buf = WriteLongToByteList (0x0, buf,28);
// NEXT LINE: 0x10 CHANGED TO 0x1!!!!!
       buf = WriteLongToByteList (0x1, buf,32);
       buf = WriteLongToByteList (0x0, buf,36);
       fos.write(buf);

       /* data-entry */
       buf = WriteLongToByteList (0x0, buf, 0);
       buf = WriteLongToByteList (0x1, buf, 4);   //PROGBITS
       buf = WriteLongToByteList (0x3, buf, 8);   //write+alloc
       buf = WriteLongToByteList (getDataOffset(), buf,12);
       buf = WriteLongToByteList ((getDataOffset()-relocOffset), buf,16);  //file-pos
       buf = WriteLongToByteList (DataSize(), buf,20);  //file-size
       buf = WriteLongToByteList (0x0, buf,24);
       buf = WriteLongToByteList (0x0, buf,28);
       buf = WriteLongToByteList (0x4, buf,32);
       buf = WriteLongToByteList (0x0, buf,36);
       fos.write(buf);

       /* section-header-string-table-entry */
       buf = WriteLongToByteList (0xc, buf, 0);
       buf = WriteLongToByteList (0x3, buf, 4);   //STRTAB
       buf = WriteLongToByteList (0x0, buf, 8);
       buf = WriteLongToByteList (getStringTableOffset(), buf,12);
       buf = WriteLongToByteList ((getStringTableOffset()-relocOffset), buf,16);  //file-pos
       buf = WriteLongToByteList (StringTableSize, buf,20);  //file-size
       buf = WriteLongToByteList (0x0, buf,24);
       buf = WriteLongToByteList (0x0, buf,28);
       buf = WriteLongToByteList (0x1, buf,32);   //no alignment
       buf = WriteLongToByteList (0x0, buf,36);
       fos.write(buf);
     }
     catch (Exception e) {
       System.out.print("Section Header Table: ");
       System.out.println(e.getMessage());
     }
   }

 }
