package backend;

import compiler.*;
import intermediate.frame.*;
import intermediate.operators.*;
import intermediate.*;
import java.util.*;
import java.io.*;
import app.AppWindow;

public class I386LinuxBackend implements Backend {

    private compiler.Compiler compiler;
    private I386Frame frame;

    public I386LinuxBackend(compiler.Compiler compiler) {
        this.compiler = compiler;
    }

    public compiler.Compiler getCompiler() {
        return compiler;
    }

    /**
     * Gibt ein Dummyframe zurck, bentigt fr einige Berechnungen im Frontend (z.B. bei wordsize)
     */
    public Frame getFrame() {
        return new I386Frame();
    }


    public void transformToExecutable(List codelist, FrameContainer fc) {
        Assembler myAsm = new Assembler(codelist);
        AppWindow appwindow = (AppWindow)getCompiler();
        // stage 1
        myAsm.generateAsmStates();

        // stage 2
        BinarFile bin = new BinarFile();
        myAsm.generateAddresses(bin);

        // save assembler-code into ImmContainer
        appwindow.getImmContainer().setAssemblerCodeList(myAsm.getAsmList());
        // save binar file - object into ImmContainer
        appwindow.getImmContainer().setBinFile(bin);

    }
}
