/*
 * Created on 08.06.2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package backend;

import java.util.*;

import intermediate.*;
import intermediate.operators.*;


/**
 * @author user
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class Optimize {
	private List originalList;
	private List optimizedList;
	
	private boolean constantPropagation;
	private boolean leftShift;
	
	public Optimize(){
		constantPropagation = true;
		leftShift = true;
	}
	
	public List optimize(List original){
			this.originalList = original;
			this.optimizedList = original;
			
			if(constantPropagation){
				System.out.println("constantPropagation");
				constantPropagation();
			}
			if(leftShift){
				System.out.println("LSL");
				leftShift();
			}
			
			return this.optimizedList;
	}
	
	private void leftShift(){
		System.out.println("leftShift()");
		
		this.originalList = this.optimizedList;

		Iterator it = originalList.iterator();
		TreeNode origInsn;
		optimizedList = new LinkedList();

		while(it.hasNext()){
			origInsn = (TreeNode)it.next();
			
			if(origInsn instanceof BINOP){
				System.out.println("binop");

				Expression src1 = ((BINOP)origInsn).getSrc1();
				Expression src2 = ((BINOP)origInsn).getSrc2();
				TEMP dest = (TEMP)((BINOP)origInsn).getDest();

				if(src2 instanceof CONST){
					System.out.println("constant = src2");

					int srcB = ((CONST)src2).getValue();
					System.out.println("src2: "+ srcB);
				
					int op = ((BINOP)origInsn).getOperatorInt();
					int result=0;
				
					if(op == 2) {
						System.out.println("LS-BINOP");
						
						boolean finish = true;
						int i;
						int r;
						
						for(i=0; i<32 && finish; i++){
							System.out.println("i: "+i);
							r = ((srcB >> i) & 1);
							if(r == 1){
								if((r << i) == srcB){
									finish = false;
									System.out.println("fond pow 2");
								}
							}
						}

						if(!finish){
							optimizedList.add(new BINOP(6, dest, src1, new CONST(i-1)));
						}else{
							optimizedList.add(origInsn);
						}
						
						
//						optimizedList.add(new BINOP(6,src1,src2));
					}else{
						optimizedList.add(origInsn);
					}
				}else{
					optimizedList.add(origInsn);
				}


			}else{
				optimizedList.add(origInsn);
			}
		}
	};



	private void constantPropagation(){
		
		Iterator it = originalList.iterator();
		TreeNode origInsn;
		optimizedList = new LinkedList();

		while(it.hasNext()){
			origInsn = (TreeNode)it.next();
			
			if(origInsn instanceof BINOP){
				System.out.println("binop");

				Expression src1 = ((BINOP)origInsn).getSrc1();
				Expression src2 = ((BINOP)origInsn).getSrc2();

				if(src1 instanceof CONST && src2 instanceof CONST){
					System.out.println("src1 & src2 are constants...");
					int srcA = ((CONST)src1).getValue();
					int srcB = ((CONST)src2).getValue();
				
					int op = ((BINOP)origInsn).getOperatorInt();
					int result=0;
				
					switch (op) {
						case 0: result = srcA + srcB; break;
						case 1: result = srcA - srcB; break;
						case 2: result = srcA * srcB; break;
						case 3: result = srcA / srcB; break;
						case 4: result = srcA & srcB; break;
						case 5: result = srcA | srcB; break;
						case 6: result = srcA << srcB; break;
						case 7: result = srcA >> srcB; break;
						case 8: result = srcA ^ srcB; break;
					}

					System.out.println("result: " + result);
					
					TEMP dest = (TEMP)((BINOP)origInsn).getDest();

					dest.setConstantPropagationValue(result);
					
					propagateConstant(dest);

				}else{
					System.out.println("constant-propagation: this insn isnt to optimize");
					optimizedList.add(origInsn);
				}

			}//end BINOP
			else{
				System.out.println("constant-propagation: this insn isnt to optimize");
				optimizedList.add(origInsn);
			}
				
			
		}//end WHILE(itr.next())

	}
	
	private void propagateConstant(TEMP tmp){
		Iterator it = originalList.iterator();
		TreeNode origInsn;
		
		while(it.hasNext()){
			origInsn = (TreeNode)it.next();
			
			if(origInsn instanceof BINOP){
				System.out.println("propagate Constant- binop");

				Expression src1 = ((BINOP)origInsn).getSrc1();
				Expression src2 = ((BINOP)origInsn).getSrc2();

				if(src1 instanceof TEMP){
					if(src1.equals(tmp)){
						System.out.println("propagate: foundsrc1");
						((BINOP)origInsn).setSrc1(new CONST(tmp.getConstantPropagationValue()));						
					}
				}
				if(src2 instanceof TEMP){
					if(src2.equals(tmp)){
						System.out.println("propagate: foundsrc2");
						((BINOP)origInsn).setSrc2(new CONST(tmp.getConstantPropagationValue()));						
					}
				}
			}else if(origInsn instanceof MOVE){
				System.out.println("propagate Constant- move");

				Expression src1 = (Expression)origInsn.getFirstChild();
				Expression src2 = (Expression)origInsn.getFirstChild().getNextSibling();

				if(src1 instanceof TEMP){
					if(src1.equals(tmp)){
						System.out.println("propagate: foundsrc1");
						((MOVE)origInsn).setDest(new CONST(tmp.getConstantPropagationValue()));						
					}
				}
				if(src2 instanceof TEMP){
					if(src2.equals(tmp)){
						System.out.println("propagate: foundsrc2");
						((MOVE)origInsn).setSrc(new CONST(tmp.getConstantPropagationValue()));						
					}
				}
			}else if(origInsn instanceof MEM){
				System.out.println("propagate Constant- mem");
				Expression src1 = (Expression)origInsn.getFirstChild();

				if(src1 instanceof TEMP){
					if(src1.equals(tmp)){
						System.out.println("propagate: foundsrc1");
						((MEM)origInsn).setLoc(new CONST(tmp.getConstantPropagationValue()));						
					}
				}
			
			}else if(origInsn instanceof OUTPUT){
				System.out.println("propagate Constant- output");
				Expression src1 = (Expression)origInsn.getFirstChild();

				if(src1 instanceof TEMP){
					if(src1.equals(tmp)){
						System.out.println("propagate: foundsrc1");
						((OUTPUT)origInsn).setLoc(new CONST(tmp.getConstantPropagationValue()));						
					}
				}
			
			}

		}

	
	}

}
