package backend.operators;

import backend.AsmStatement;
import backend.BinarFile;


public class AsmCall extends AsmStatement {

//  private int targetLabelID;
  private String labelName;
  private AsmLabel target;
  private boolean recCall;

/*  public AsmCall(int labelID) {
    targetLabelID = labelID;
  }
*/
  public AsmCall(String label, boolean recursive) {
    labelName = label;
    recCall = recursive;
    length = 13;
//    targetLabelID = 0;
  }

  public String toString() {
    String retval;
    /*if (targetLabelID==0)*/ retval=labelName;
    //else retval=String.valueOf(targetLabelID);
    return "CALL " + retval;
  }

  public String getLabelName() {
    return labelName;
  }

  public void setTargetLabel(AsmLabel label) {
    target = label;
  }

  public byte[] getCode (byte[] list, int off) {
    /* push static link */
    if (recCall) {
      // push (ebp)
      list[off  ] = (byte)(0xff);  // push opcode
      list[off+1] = (byte)(0x75);  // [ebp]+disp8
      list[off+2] = (byte)(0x00);  // disp8
    }
    else {
      // push ebp
      list[off  ] = NOP;
      list[off+1] = NOP;
      list[off+2] = (byte)(0x55);  // push ebp
    }

    /* push dynamic link */
    list[off+3] = (byte)(0x55);  // push ebp

    /* call target */
    list[off+4] = (byte)(0xe8);  // call opcode

    if (target==null) System.out.println("TARGET = NULL!");
    int value = target.getPos() - this.getPos();
    value -= this.getLength();
    list = BinarFile.WriteLongToByteList(value, list, off+5);

    /* remove dynamic link */
    list[off+ 9] = (byte)(0x5d);  // pop ebp

    /* remove static link */
    list[off+10] = (byte)(0x83);  // add opcode
    list[off+11] = (byte)(0xc4);  // to ESP
    list[off+12] = (byte)(0x04);  // $0x04

    return list;
  }

}
