package backend.operators;

import backend.AsmStatement;

public class AsmCompare extends AsmStatement {

  private int relation;
  private Register left;
  private Register right;
  private Register result;

  public static final int EQ = 0;
  public static final int NE = 1;
  public static final int GT = 2;
  public static final int LT = 3;
  public static final int GE = 4;
  public static final int LE = 5;

  private String relString() {
    String retval="NOT IMPLEMENTED";
    switch (relation) {
      case EQ: retval="=="; break;
      case NE: retval="!="; break;
      case GT: retval=">"; break;
      case LT: retval="<"; break;
      case GE: retval=">="; break;
      case LE: retval="<="; break;
    }
    return retval;
  }


  public AsmCompare(int reg1, int reg2, int res, int rel) {
    left = new Register(reg1);
    right = new Register(reg2);
    relation = rel;
    result = new Register(res);
  }

  public String toString() {
      return "CMP " + left.toString() + relString() + right.toString() + " => " + result.toString();
  }
}
