package backend.operators;

import backend.BinarFile;

public class AsmDiv extends BinOp {

  public AsmDiv(int divisor) {
    super(Register.EAX, divisor);
    // dividiert immer eax durch ein anderes Register; Ergebnis: eax
    if (divisor==Register.EDX) System.out.println("MUL will cause error");
    length = 9;
  }

  public String toString() {
      return "DIV " + src_dest.toString() + " /= " + operand.toString();
  }

  public byte[] getCode (byte[] list, int off) {
    /* save edx */
    list[off  ] = (byte)(0x52);  // push edx

    /* clear edx */
    list[off+1] = (byte)(0xba);  // mov edx,
    BinarFile.WriteLongToByteList(0, list, off+2);  // 0x0

    /* divide */
    list[off+6] = (byte)(0xf7);  // eax = edx:eax div
    list[off+7] = (byte)(0xf0+operand.get());  //operand

    list[off+8] = (byte)(0x5a);  // pop edx
    return list;
  }

}
