package backend.operators;

import backend.BinarFile;

public class AsmFLMain extends AsmFL {

  public AsmFLMain(int block) {
    super(block);
    if (block!=0) System.out.println("AsmFLMain(): Error");
    length = 12; //5 + super.getLength(); //0;
  }


  public byte[] getCode (byte[] list, int off) {

    // Load 1 to eax
    list[off] = (byte)(0xb8);
    BinarFile.WriteLongToByteList(1, list, off+1);
    // Load 0 to ebx
    list[off+5] = (byte)(0xbb);
    BinarFile.WriteLongToByteList(0, list, off+6);
    // Int 0x80
    list[off+10] = (byte)(0xcd);
    list[off+11] = (byte)(0x80);

    return list;
  }


  public byte[] getCode2 (byte[] list, int off) {

    /* leave normal frame */
    list = super.getCode(list,off+5);

    /* simulate Call-Frame */
    list[off  ] = (byte)(0x5d);  // pop ebp
    list[off+1] = (byte)(0x5d);  // pop ebp
    list[off+2] = (byte)(0x89);  // mov
    list[off+3] = (byte)(0xec);  // ebp=>esp
    list[off+4] = (byte)(0x5d);  // pop ebp


    return list;
  }



  public byte[] getCodeCausesError (byte[] list, int off) {

    /*  After FrameLeave-Main should be a jump to >Exit<, so the old frame
     *  could be ignored.
     */

    return list;
  }

}
