package backend.operators;

import backend.AsmStatement;
import backend.BinarFile;

public class AsmJump extends AsmStatement {

  private String labelName;
  private AsmLabel target;

  public AsmJump(String label) {
    labelName = label;
    length = 5;
    target = null;
  }

  public String toString() {
    String retval;
    retval=labelName;
    return "JUMP " + retval;
  }

  public String getLabelName() {
    return labelName;
  }

  public void setTargetLabel(AsmLabel label) {
    target = label;
  }

  public byte[] getCode (byte[] list, int off) {
    // Opcode
    list[off] = (byte)(0xe9);
    if (target==null) System.out.println("TARGET = NULL!");

    int value = target.getPos() - this.getPos();
    value -= this.getLength();

    list = BinarFile.WriteLongToByteList(value, list, off+1);

    return list;
  }
}
