package backend.operators;

import backend.AsmStatement;
import backend.BinarFile;

public class AsmLoad extends AsmStatement {

//  private Memory memory;
  private Register register;
  private int temp;

/*  public AsmLoad(int mem, int reg) {
    register = new Register(reg);
    memory = new Memory(mem);
  }
*/

  public AsmLoad(int temp, int reg) {
    register = new Register(reg);
    this.temp = temp;
    length = 9;
  }

  public String toString() {
      return "LOAD [Temp" + String.valueOf(temp) + "] => " + register.toString();
  }

  public byte[] getCode (byte[] list, int off) {

    /* load HS-addr in register */
    list[off] = (byte) (0xb8 + register.get());  // mov r32,
    int value = userData + (4 * temp);
    list = BinarFile.WriteLongToByteList(value, list, off+1);  // addr from temp

    /* load value in register */
    list[off+5] = (byte) (0x8b);  // mov
    list[off+6] = (byte) (9*register.get());  // [r32]=>r32

    /* and now, load its value in the register */
    list[off+7] = (byte) (0x8b);  // mov
    list[off+8] = (byte) (9*register.get());  // [r32]=>r32

    return list;
  }

}
