package backend.operators;

public class AsmMul extends BinOp {

  public AsmMul(int factor) {
    super(Register.EAX, factor);
    // multipliziert immer eax mit einem anderen Register; Ergebnis: eax
    length = 4;
  }

  public String toString() {
      return "MUL " + src_dest.toString() + " *= " + operand.toString();
  }

  public byte[] getCode (byte[] list, int off) {
    list[off  ] = (byte)(0x52);  // push edx
    list[off+1] = (byte)(0xf7);  // mul edx:eax := eax *
    list[off+2] = (byte)(0xe0+operand.get());  //operand
    list[off+3] = (byte)(0x5a);  // pop edx
    return list;
  }

}
