package frontend.parsetree;

import intermediate.*;
import intermediate.operators.*;
import antlr.Token;

public class BeginNode extends PL0Node {

    public BeginNode(Token tok) {
        super(tok);
    }

    public Statement convertStatement() {
        PL0Node currentNode = (PL0Node)getFirstChild();
        //Der Knoten kann null sein, wenn zwischen BEGIN und END nichts steht
        if (currentNode == null) {
            //return new MOVE(new TEMP(new Temp()), new CONST(0)); //dann gib Dummy Statement zurck
            return null;
        }
        //Ansonsten bearbeite alles zwischen BEGIN und END
        if (currentNode.getNextSibling() == null) {
            return currentNode.convertStatement();
        }
        return computeNextStatement(currentNode);
    };

    private Statement computeNextStatement(PL0Node currentNode) {
        PL0Node sibling = (PL0Node)currentNode.getNextSibling();
        if (sibling.getNextSibling() != null) {
            return new SEQ(currentNode.convertStatement(), computeNextStatement(sibling));
        } else {
            return new SEQ(currentNode.convertStatement(), sibling.convertStatement());
        }
    }

}
