package frontend.symbol;

import java.util.*;

/**
 * Stack, der von der Symboltabelle benutzt wird, um die Sichtbarkeitsbereiche zu verwalten.
 */
class ScopeStack extends java.util.Stack {

    /**
     * Sucht nach einer Definition im Stack
     */
    public Definition lookup(String name) {
        //Benutze die lookup() Methode des obersten Elementes. Diese fhrt eine rekursive Suche
        //durch, ohne den ScopeStack zu benutzen, da jede Definition (und daher auch jede ScopeDef)
        //ihren Eltern-Gltigkeitsbereich kennt.
        return ((ScopeDef)elementAt(size() - 1)).lookup(name);
    }

    public int[] lookupPos(String name) {
        int[] posarray = new int[]{0,0};
        Definition d = null;
        while (posarray[0] < size() && d == null) {
            Hashtable scopeElems = ((ScopeDef)elementAt(size()-posarray[0]-1)).getElements();
            d = (Definition)scopeElems.get(name);
            posarray[0]++;
        }
        posarray[0]--;
        posarray[1] = d.getPosInScope();
        return posarray;
    }


}
