package frontend.symbol.visualize;

import antlr.collections.AST;
import frontend.symbol.*;

import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;

public class JTreeSymtabModel implements TreeModel {

    ScopeDef root;
    SymbolTable table = SymbolTable.getSymbolTable();

    /**
     *
     */
    public JTreeSymtabModel() {
        this.root = table.getBaseScope();
    }

    /**
     *
     * @param parent
     * @param index
     * @return
     */
    public Object getChild(Object parent, int index) {
        if (parent == null) {
            return null;
        }
        ScopeDef p = (ScopeDef)parent;
        Iterator it = p.scopeIdentifiers();
        Definition c = (Definition)it.next();
        if (c == null) {
            throw new ArrayIndexOutOfBoundsException("node has no children");
        }
        int i = 0;

        while (it.hasNext() && i < index) {
            c = (Definition)it.next();
            i++;
        }
        return c;
    }

    /**
     *
     * @param parent
     * @return
     */
    public int getChildCount(Object parent) {
        if (parent == null) {
            throw new IllegalArgumentException("root is null");
        }
        ScopeDef p = (ScopeDef)parent;
        Iterator it = p.scopeIdentifiers();
        Definition c = null;
        int i = 0;
        while (it.hasNext()) {
            c = (Definition)it.next();
            i++;
        }
        return i;
    }

    /**
     *
     * @param parent
     * @param child
     * @return
     */
    public int getIndexOfChild(Object parent, Object child) {
        if (parent == null || child == null) {
            throw new IllegalArgumentException("root or child is null");
        }
        ScopeDef p = (ScopeDef)parent;
        Iterator it = p.scopeIdentifiers();
        Definition c = (Definition)it.next();
        if (c == null) {
            throw new ArrayIndexOutOfBoundsException("node has no children");
        }
        int i = 0;
        while (it.hasNext() && c != child) {
            i++;
        }
        if (c == child) {
            return i;
        }
        throw new java.util.NoSuchElementException("node is not a child");
    }

    /**
     *
     * @return
     */
    public Object getRoot() {
        return root;
    }

    /**
     *
     * @param node
     * @return
     */
    public boolean isLeaf(Object node) {
        if (node == null) {
            throw new IllegalArgumentException("node is null");
        }
        ScopeDef p = (ScopeDef)node;
        return !p.scopeIdentifiers().hasNext();
    }

    /**
     *
     * @param l
     */
    public void removeTreeModelListener(TreeModelListener l) {
    }

    /**
     *
     * @param l
     */
    public void addTreeModelListener(TreeModelListener l) {
    }

    public void valueForPathChanged(TreePath path, Object newValue) {
    }
}
