package intermediate.operators;

import intermediate.*;

public class BINOP extends Expression {

    public static final int PLUS = 0;
    public static final int MINUS = 1;
    public static final int MUL = 2;
    public static final int DIV = 3;
    public static final int AND = 4;
    public static final int OR = 5;
    public static final int LSHIFT = 6;
    public static final int RSHIFT = 7;
    public static final int XOR = 8;

    private Expression left, right, dest;
    private int binop;

    public BINOP(int binop, Expression left, Expression right) {
        this.binop = binop;
        this.dest = null;
        this.left = left;
        this.right = right;
        addChild(left);
        addChild(right);
    }

	public BINOP(int binop, Expression dest, Expression left, Expression right) {
		this.binop = binop;
		this.dest = dest;
		this.left = left;
		this.right = right;
		addChild(left);
		addChild(right);
	}

    public String toString() {
        return "BINOP(" + getOperator() + ")";
    }

    public String toStringList() {
//    	if(dest == null){
			return getOperator() + "(" + left.toStringList() + ", " + right.toStringList() + ")";
//    	}
//		return dest.toStringList() +" = "+ getOperator() + "(" + left.toStringList() + ", " + right.toStringList() + ")";
    }

    public String getOperator() {
        String op = null;
        switch (binop) {
            case (PLUS): op = "+"; break;
            case (MINUS): op = "-"; break;
            case (MUL): op = "*"; break;
            case (DIV): op = "/"; break;
            case (AND): op = "AND"; break;
            case (OR): op = "OR"; break;
            case (LSHIFT): op = "LSHIFT"; break;
            case (RSHIFT): op = "RSHIFT"; break;
            case (XOR): op = "XOR"; break;
        }
        return op;
    }

    public int getOperatorInt(){
    	return binop;
    }
    
    public Expression getSrc1(){
    	return left;
    }
    public void setSrc1(Expression src){
    	this.left = src;
    }

	public Expression getSrc2(){
		return right;
	}
	public void setSrc2(Expression src){
		this.right = src;
	}

	public Expression getDest(){
		return dest;
	}

}